; dbeast.asm
; dumps 'Navy Seals' cartridge to disk
; Version 1.1


* = $0801

.INCLUDE SYSTEM.ASM			; KERNAL functions

		.byte $0c,$08,$ce,$07,$9e,$20,$32,$30
		.byte $36,$32,$00,$00,$00

		LDX  #$ff
		TXS

		JSR  $e544		; clear screen
		JSR  _textout
		.text "ENABLE EXROM/GAME LINES AND PRESS FIRE."
		.byte 0

		JSR  _waitFire		; wait for joystick fire
		JSR  _textout
		.text "OK"
		.byte 0
		JSR  _textout
		.text "INSERT DISK 1 AND PRESS FIRE."
		.byte 0
		JSR  _waitFIRE

		LDA  #$37		; enable cartridge banks
		STA  $01

		JSR  _resetu

		LDA  #$00		; save first disk side
_saveL1		STA  _cartbank
		JSR  _init1
		JSR  $0111
		JSR  _openfiles
		JSR  _saveblock
		JSR  _closefiles
		CLC
		LDA  _cartbank
		ADC  #$01
		CMP  #$10
		BNE  _saveL1


		LDA  #$06
		STA  $d020		; ext. color
		STA  $d021		; backgnd. color

		JSR  _textout
		.text "INSERT DISK 2 AND PRESS FIRE."
		.byte 0
		JSR  _waitFIRE


		JSR  _resetu

		LDA  #$10		; save second disk side
_saveL2		STA  _cartbank
		JSR  _init1
		JSR  $0111
		JSR  _openfiles
		JSR  _saveblock
		JSR  _closefiles
		CLC
		LDA  _cartbank
		ADC  #$01
		CMP  #$20
		BNE  _saveL2

		LDA  #$06
		STA  $d020		; ext. color
		STA  $d021		; backgnd. color

		JSR  _textout
		.text "CARTRIDGE DUMPING SUCCESSFUL!"
		.byte 0
		JSR  _waitFIRE
		
		RTS

_cartbank	.byte 0



_textout	PLA			; (lb return)
		STA  _textoutL1+1
		PLA			; (hb return)
		STA  _textoutL1+2

		LDX  #$01
_textoutL1	LDA  $1000,X
		BEQ  _textoutJ1
		CMP  #$41
		BCC  _outadr
		SEC
		SBC  #$40
_outadr		STA  $03ff,X
		INX
		BNE  _textoutL1

_textoutJ1	CLC
		TXA
		ADC  _textoutL1+1
		TAY
		LDA  _textoutL1+2
		ADC  #$00
		PHA
		TYA
		PHA

		CLC
		LDA  _outadr+1
		ADC  #$28
		STA  _outadr+1
		BCC  _textoutEnd
		INC  _outadr+2
_textoutEnd	RTS	
		

_waitFire	LDA  $dc00		; wait for fire button up
		AND  $dc01
		AND  #$10
		BEQ  _waitFire
_waitFireL1	LDA  $dc00		; wait for fire button
		AND  $dc01
		AND  #$10
		BNE  _waitFireL1
_waitFireL2	LDA  $dc00		; wait for fire button up again
		AND  $dc01
		AND  #$10
		BEQ  _waitFireL2
		RTS


_printblock     PHA
		LDA  _outadr+1		; (lb destination)
		STA  _outadr2+1
		STA  _outadr3+1
		STA  _outadr4+1
		LDA  _outadr+2		; (hb destination)
		STA  _outadr2+2
		STA  _outadr3+2
		STA  _outadr4+2
		LDX  #$01

_printblockL1	LDA  _textsaveblock-1,X
		BEQ  _printblockJ1
		CMP  #$41
		BCC  _outadr2
		SEC
		SBC  #$40
_outadr2	STA  $03ff,X
		INX
		BNE  _printblockL1

_printblockJ1	PLA
		LDY  #$ff
_tenL		INY
		SEC
		SBC  #$0a
		BPL  _tenL
		PHA
		CLC
		TYA
		ADC  #$30
_outadr3	STA  $033f,X
		INX
		PLA
		CLC
		ADC  #$3a
_outadr4	STA  $033f,X
		RTS		

_textsaveblock	.text "SAVING BLOCK: "
		.byte 0


_saveblock	LDA  _cartbank
		JSR  _printblock

		LDA  _cartbank
		
		LDA  #$20
		STA  $fc
		LDA  #$00
		STA  $fb

_saveblockL1	JSR  _resetbuffer
		JSR  _transferblock
		JSR  _issueu2

		CLC
		INC  $fc
		LDA  $fc
		CMP  #$40
		BEQ  _saveblockEnd
		BNE  _saveblockL1
_saveblockEnd	RTS



_openfiles	LDA  #$0f
		TAY
		LDX  #$08
		JSR  SETLFS		; OPEN 15,8,15,""
		LDA  #$00
		JSR  SETNAM
		JSR  OPEN

		LDA  #$02
		TAY
		LDX  #$08
		JSR  SETLFS		; OPEN 2,8,2,"#2" (buffer #2)
		LDX  #<_fnbuffer
		LDY  #>_fnbuffer
		LDA  #$02
		JSR  SETNAM
		JSR  OPEN

		RTS
_fnbuffer	.text "#2"

_closefiles	JSR  CLALL
		RTS

_resetbuffer	LDA  #$08		; reset the buffer pointer
		JSR  LISTEN
		LDA  #$ff
		JSR  SECOND
		LDY  #$00
_sendtextL1	LDA  _bptext,Y
		JSR  CIOUT
		INY
		CPY  #$07
		BNE  _sendtextL1
_sendtextJ1	JSR  UNLSN
		RTS
_bptext		.text "B-P:2,0"
		


_transferblock  LDA  #$08		; transfer 256 byte to buffer 2
		LDA  #$08		; transfer 256 byte to buffer 2
		JSR  LISTEN
		LDA  #$62
		JSR  SECOND
		LDY  #$00
_transferL1	LDA  ($fb),Y
		JSR  CIOUT
		INY
		BNE  _transferL1
		JSR  UNLSN

		RTS


_issueu2	LDA  #$08		; write buffer to disk
		JSR  LISTEN
		LDA  #$ff
		JSR  SECOND
		LDY  #$00
_u2L1		LDA  _u2text,Y
		JSR  CIOUT
		INY
		CPY  #$0c
		BNE  _u2L1
_u2J1		JSR  UNLSN

		JSR  _incdiskblock
		RTS
_u2text		.text "U2:2,0,01,00"


_resetu 	LDA  #$31		; reset Track
		STA  _u2text+8
		LDA  #$30		; reset Sector
		STA  _u2text+7
		STA  _u2text+10
		STA  _u2text+11
		LDA  #$01
		STA  _track
		LDA  #$00
		STA  _sector
		RTS

_incdiskblock	LDA  _track
		TAX
		LDA  _sector
		CLC
		ADC  #$01
		CMP  _sectorstrack,X
		BEQ  _inctrack
		LDA  _u2text+11
		CLC
		ADC  #$01
		CMP  #$3a
		BNE  _incsectorEnd
		INC  _u2text+10
		LDA  #$30
_incsectorEnd   STA  _u2text+11
		INC  _sector
		RTS

_inctrack	LDA  _u2text+8
		CLC
		ADC  #$01
		CMP  #$3a
		BNE  _inctrackEnd
		INC  _u2text+7
		LDA  #$30
_inctrackEnd	STA  _u2text+8
		INC  _track
		LDA  #$00		; reset Sector
		STA  _sector
		LDA  #$30
		STA  _u2text+10
		STA  _u2text+11
		RTS	

_track		.byte 1
_sector		.byte 0

_sectorstrack	.byte 00,21,21,21,21,21,21,21
		.byte 21,21,21,21,21,21,21,21
		.byte 21,21,19,19,19,19,19,19
		.byte 19,18,18,18,18,18,18,17
		.byte 17,17,17,17



_busywait	LDX  #$00
_bwL3		LDY  #$00
_bwL2	        LDA  #$01
_bwL1		SEC
		SBC  #$01
		BNE  _bwL1
		DEY
		BNE  _bwL2
		DEX
		BNE  _bwL3
		RTS	


_init1		SEI
		CLD
		LDX  #$ff
		STX  $dc02		; Data Direction A Joysticks/Keyb.
		LDA  #$e7
		STA  $01
		LDA  #$2f
		STA  $00
		INX			; X = #$00
		STX  $d020		; ext. color
		STX  $d021		; backgnd. color
		STX  $d01a		; Interrupt Enable
		STX  $d015		; Sprite Enable
		STX  $d011		; VIC Ctrl (screen off)
		STX  $dc03		; Data Direction B (Timer, joyst.)
		STX  $dd03		; Data Direction B (User Port)
		LDA  #$0f
		STA  $d019		; VIC interrupt Flag
		LDX  #$7f
		STX  $dc0d		; CIA Int. Ctrl Mask
		STX  $dd0d		; CIA Int. Ctrl Mask
		STX  $dc00		; CIA port A
		LDA  #$3f
		STA  $dd02		; Data DIr Port A
		LDA  #$90
		STA  $dd00		; CIA #2 port A (ser. bus)
		LDY  #$18
		LDA  #$00
_init1L1	STA  $0011,Y
		DEY
		BPL  _init1L1
;		LDA  $dc00
;		AND  $dc01
;		AND  #$10
;		BNE  _init1J1
;		JMP  _deadend
;_init1J1	BIT  $d419		; (A/D Converter paddle 1)
;		BMI  _init1J2
;		LDA  $dc00
;		AND  #$10
;		BNE  _init1J2
;		JMP  _deadend
_init1J2	JMP  _copy0111


_deadend	LDA  #$02
		STA  $d020
		STA  $d021
		JMP  _deadend
		
		


_copybank	LDA  _cartbank
		ORA  #$80
		STA  $de00
;		LDX  #$a0
;		AND  #$10
;		BNE  _copya000  
		LDX  #$80		; always copy from $8000 for Navy Seals
_copya000	STX  $14
		LDA  #$20		; copy to $2000
		STA  $af
		LDA  #$00		; lb start address
		STA  $13
		STA  $ae

		LDY  #$00
_readbyteL	LDA  ($13),Y
		CMP  ($13),Y
		BNE  _readbyteL
		STA  ($ae),Y
		INC  $13
		INC  $ae
		BNE  _readbyteL
		INC  $14
		INC  $af
		LDA  $af
		CMP  #$40
		BNE  _ReadbyteL
		
		LDA  #$80
		STA  $de00
		LDA  #$37		; #$35 ?
		STA  $01
;		LDX  $1f
;		TXS
		CLC
		RTS


_copy0111	LDY  #$d4
_copy0111L	LDA  _copybank-1,Y
		STA  $0110,Y
		DEY
		BNE  _copy0111L
		RTS
